/*	This script created by Christopher Bradford, Alive! Online.

	You may distribute this freely, but please keep the headers intact.

	Installation:
	Create a custom button for the .js file
	
	This script will do a sort on selected lines (you can also select partial 
	lines) based on the text of the first link on each line. For example:
	
	<a href="alink.html">Q Link</a>
	<a href="other.html">A Link</a>
	
		becomes
		
	<a href="other.html">A Link</a>
	<a href="alink.html">Q Link</a>
	
	The sort is done by line, and it will not change any tags or text you have 
	on the line.
	
	You can modify the script to sort in descending order instead of ascending 
	order by modifying line 88 of the script (see the comment there).

	Copyright 2000
 	Christopher Bradford
	bradford@aliveonline.com
*/


// MessageBox constants
var hsOK = 0;
var hsYesNoCancel = 3;
var hsYesNo = 4;
var hsStop = 16;
var hsQuestion = 32;
var hsAlert = 48;
var hsInfo = 64;

// MessageBox button value constants
var hsOKValue = 1;
var hsCancel = 2;
var hsAbort = 3;
var hsRetry = 4;
var hsIgnore = 5;
var hsYes = 6;
var hsNo = 7;

var app = Application;
var active = app.ActiveDocument;

var anchorRE = /<a[^>]*>(([^<]|<\/?[^a][^>]*>)*)<\/a>/i;

function Main() {

	active.BeginUpdate();
	var startText = active.SelText;
	if (startText.slice(startText.length - 1) == "\n") {
		active.SelLength = startText.replace(/\r/g, "").length - 1;
		startText = active.SelText;
	}
	var startPoint = active.SelStart;
	var endPoint = startPoint + startText.replace(/\r/g, "").length;
	active.SelLength = 0;
	active.SelStart = startPoint;
	active.CursorLineStart(false);
	var newStart = active.SelStart;
	active.SelStart = endPoint;
	active.CursorLineEnd(false);
	var newEnd = active.SelStart;
	active.SelStart = newStart;
	active.SelLength = newEnd - newStart;
	var selectedLines = active.SelText.replace(/\r/g, "").split(/\n/);
	sortedLines = selectedLines.sort(compareAnchors);
	active.SelText = sortedLines.join("\r\n");
	active.SelStart = startPoint;
	active.SelLength = 0;
	active.EndUpdate();

}

function compareAnchors(lineOne, lineTwo) {

/*	To change the function so it sorts in descending order rather than
	ascending order, change the line below to read:
	var sortAscending = false;	*/

var sortAscending = true;

if (sortAscending) {
	var lt = -1;
	var gt = 1;
}
else {
	var lt = 1;
	var gt = -1;
}

var eq = 0;

	if (lineOne.search(anchorRE) != -1) {
		var lineOneHasAnchor = true;
		anchorRE.exec(lineOne);
		var anchorOneText = RegExp.$1;
	}
	else {
		var lineOneHasAnchor = false;
	}
	if (lineTwo.search(anchorRE) != -1) {
		var lineTwoHasAnchor = true;
		anchorRE.exec(lineTwo);
		var anchorTwoText = RegExp.$1;
	}
	else {
		var lineTwoHasAnchor = false;
	}
	if (!lineOneHasAnchor && lineTwoHasAnchor) {
		return(lt);
	}
	else if (lineOneHasAnchor && !lineTwoHasAnchor) {
		return(gt);
	}
	else if (!(lineOneHasAnchor || lineTwoHasAnchor)) {
		return(eq);
	}
	else {
		if (anchorOneText.toLowerCase() == anchorTwoText.toLowerCase()) {
			return(eq);
		}
		else if (anchorOneText.toLowerCase() > anchorTwoText.toLowerCase()) {
			return(gt);
		}
		else {
			return(lt);
		}
	}
}
